#include "matchlots.h"
#include <stdio.h>

int main (int argc, char **argv)
{

   int i, j;
   
   if (argc < 3) {
       print_usage();
       return -1;
   }
   for (j= 1; j < argc; j++) {
       printf ("%s ", argv[j]);
   }
   printf ("\n");
   for (i= 1; i < argc; i++) {
   
       for (j= 1; j < argc; j++) {
           if (i == j)
	       matchfiles (argv[i], argv[j], TRUE);
	   else
	       matchfiles (argv[i], argv[j], FALSE);
       }
       printf ("\n");
   }
   return 0;
}


void matchfiles (char *file1, char *file2, char similar)
{
    PLATE *list1;
    PLATE *list2;
    int num_valid1;
    int num_valid2;
    int num_plate1;
    int num_plate2;
 
    
    list1= read_plate_list(file1);
    if (list1 == NULL)
        exit (-1);
    num_valid1= valid_plates;
    num_plate1= tot_plates;
    list2= read_plate_list(file2);
    if (list2 == NULL) {
        free_plate_list(list1);
        exit (-1);
    }
    num_valid2= valid_plates;
    num_plate2= tot_plates;   
    matchplates(list1,list2, num_plate1, num_valid1, num_plate2, num_valid2,
       similar);
    free_plate_list(list1);
    free_plate_list(list2);
}


void print_usage (void)
{
    fprintf (stderr,"matchlots file1 file2 file3.... filen\n");
    fprintf (stderr,"produces a grid matching files with each other\n");
    
}

void matchplates (PLATE *list1, PLATE *list2, int np1, int nv1,
    int np2, int nv2, char similar)
{
    PLATE *tmpptr1;
    PLATE *tmpptr2;
    int match= 0;
    float real_match;
    
    for (tmpptr1= list1; tmpptr1 != NULL; tmpptr1= tmpptr1->next) {
        for (tmpptr2= list2; tmpptr2 != NULL; tmpptr2= tmpptr2->next) {
	    if (strlen (tmpptr1->plate) > 0 && strlen (tmpptr2->plate) > 0 &&
	      strcmp (tmpptr1->plate, tmpptr2->plate) == 0) {
	        match++;     
	    }
	}
    }
 /*   printf ("Raw matches %d\n", match);
    printf ("Matches as %% of valid plates in file 1 %f %%\n", 100.0 
        *(float) match/ (float) nv1);
    printf ("Matches as %% of total plates in file 1 %f %%\n", 100.0 *
        (float) match/ (float) np1);  
    printf ("Matches as %% of possible matches %f %%\n", 100.0 *
        (float) match/ ( (float) nv1 * (float) nv2) ); */
    real_match= (float) match - (P_MATCH * (float) nv1 * (float) nv2);
    
    if (similar == TRUE) 
        printf ("%5.01f ",100.0 * real_match/ (float)nv1);
    else {
         printf ("%5.01f ",100.0* real_match *(float) np2 / 
        (  (float) nv1 * (float) nv2 ));
    }
/*
    printf ("Estimated number of real matches %d\n", (int)
        real_match); 
    printf (
    "Estimated number of real matches as %% of file 1 %f %%\n",
        100.0 *real_match / (float)nv1);
    real_match= real_match * (float) np1 * (float) np2 / 
        (  (float) nv1 * (float) nv2);
    printf ("Estimated number of real matches in complete data %d\n", (int)
        real_match);
    printf (
    "Estimated number of real matches in complete data as %% of file 1 %f %%\n",
        100.0 *real_match / (float)np1);*/
}


